---------------------------------------------------------------------------------------------------
--
-- Title       : ula4bits
-- Design      : ula4bits
-- Author      : CPD
-- Company     : PUCRS
--
---------------------------------------------------------------------------------------------------
--
-- File        : ula4bits.vhd
-- Generated   : Tue Mar 21 16:06:59 2006
-- From        : interface description file
-- By          : Itf2Vhdl ver. 1.20
--
---------------------------------------------------------------------------------------------------
--
-- Description : 
--
---------------------------------------------------------------------------------------------------

--{{ Section below this comment is automatically maintained
--   and may be overwritten
--{entity {ula4bits} architecture {ula4bits}}

library IEEE;
use IEEE.STD_LOGIC_1164.all;
package ula is
	type op is (soma, subtracao, incr, decr, op_and, op_or, op_xor, op_not);
end ula;

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_UNSIGNED.all;
use work.ula.all;

entity ula4bits is
	port(
		 ent_A : in STD_LOGIC_VECTOR(3 downto 0);
		 ent_B : in STD_LOGIC_VECTOR(3 downto 0);
		 operacao : in op;
		 N : out STD_LOGIC;
		 Z : out STD_LOGIC;
		 C : out STD_LOGIC;
		 V : out STD_LOGIC;
		 saida : out STD_LOGIC_VECTOR(3 downto 0)
	     );
end ula4bits;

--}} End of automatically maintained section

architecture ula4bits of ula4bits is
signal int_ent_A : STD_LOGIC_VECTOR(4 downto 0);
signal int_ent_B : STD_LOGIC_VECTOR(4 downto 0);
signal int_saida : STD_LOGIC_VECTOR(4 downto 0);
signal sum_V, sub_V : std_logic;

begin				  
	int_ent_A <= '0' & ent_A;
	int_ent_B <= ('1' & ent_B) when (operacao=subtracao or operacao=decr)
				else ('0' & ent_B);
	saida <= int_saida (3 downto 0);
	
	N <= int_saida(3);
	Z <= '1' when int_saida(3 downto 0)="0000" else '0';
	C <= int_saida(4);
	sum_V <= '1' when ((int_ent_A(3) xnor int_ent_B(3))='1'
						and (int_saida(3) xor int_ent_A(3))='1') else '0';
	sub_V <= '1' when ((int_ent_A(3) xor int_ent_B(3))='1'
						and (int_saida(3) xor int_ent_A(3))='1') else '0';
	with operacao select
	V <= sum_V when soma | incr,
		 sub_V when subtracao | decr,
		 '0' when others;
	
	with operacao select
	int_saida <=	int_ent_A + int_ent_B when soma,
					int_ent_A - int_ent_B when subtracao,
					int_ent_A + 1 when incr,
					int_ent_A - 1 when decr,
					int_ent_A and int_ent_B when op_and,
					int_ent_A or int_ent_B when op_or,
					int_ent_A xor int_ent_B when op_xor,
					not int_ent_A when others; 

end ula4bits;
